unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, Menus, StrBit32, Gauges, MaxMin, ExtCtrls,
  Mask;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    EdMatr: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    StatusBar1: TStatusBar;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    mnHelp: TMenuItem;
    miHelp: TMenuItem;
    Gauge1: TGauge;
    BitBtn3: TBitBtn;
    mnExit: TMenuItem;
    BnExit: TBitBtn;
    BnExecute: TBitBtn;
    mnKod: TMenuItem;
    miIshFile: TMenuItem;
    miRezFile: TMenuItem;
    miExecute: TMenuItem;
    Bevel1: TBevel;
    procedure BnExitClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BnExecuteClick(Sender: TObject);
    procedure miHelpClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EdMatrExit(Sender: TObject);
  private
    { Private declarations }
  public
    FIn,FOut : TBitFile;
    Registr : TStr_Bit;
    ZnSk,               //   
    ChislSk,            //   
    MaxSize:integer;    //     
    MatrixMass: array[1..16,1..16] of String[200];
    KoderMass: array[1..16] of TStr_Bit;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.BnExitClick(Sender: TObject);
begin   {    }
 FIn.Free;      //  ,   
 FOut.Free;
 Registr.Free;

 Close;
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin   {       }
 if OpenDialog1.Execute then Edit2.Text:=OpenDialog1.FileName;
end;

procedure TMainForm.BitBtn2Click(Sender: TObject);
begin  {       }
 if OpenDialog1.Execute then Edit3.Text:=OpenDialog1.FileName;
end;

procedure TMainForm.BnExecuteClick(Sender: TObject);
var PosSim, K, j : Integer;
    I: Byte; S:String;
begin     {    }
 Gauge1.Visible := True;
 if ( Edit2.Text = '' ) or ( Edit3.Text = '' )
   then begin ShowMessage('   ');
              Exit;
        end;
                                //   
 for i:=1 to ChislSk do begin   
   S:=Memo1.Lines.Strings[I-1];
   for j:=1 to ZnSk do begin
      S := Trim(S);
      K := Pos(' ',S)-1; if K= -1 then K := length(S);
      if K=0 then ShowMessage('    ')
             else MatrixMass[I,J]:=Copy(S,1,K);
      Delete(S,1,K);
 end; end;
                   //      
  MaxSize := 0;
  for J := 1 to ZnSk do begin
    K := 0;
    KoderMass[J] := TStr_Bit.Create;
    For PosSim := 1 to length(MatrixMass[1,J]) do
     for I:=1 to ChislSk do begin
      KoderMass[J][K] := Ord(MatrixMass[I,J][PosSim])-Ord('0');
      inc(K);
      end;
      S := KoderMass[J].Val_sim;
    MaxSize:= Max(MaxSize,K);
    end;
                          {     }
 Registr.Init_0(MaxSize);
 try
  FOut.OpenBitFile(Edit3.Text,btCreate,bt32);
  FIn.OpenBitFile(Edit2.Text,btOpenRead,bt32);
  Gauge1.MaxValue := FIn.SizeOfFile div ChislSk;
  PosSim := 0;
  while FIn.ReadStr(ChislSk) = btOk do begin   //    
    for j:=1 to ChislSk do Registr.LastBitDisplase(FIn[j-1]); //  
    Inc(PosSim);
    if (PosSim mod 10000)=0 then begin  //  
      Gauge1.Progress:=PosSim;
      Application.ProcessMessages; //     
     end;
      {    }
    for j:=1 to ZnSk do FOut.WriteBit(Registr.ModReg(KoderMass[J]) );
  end;
  FIn.CloseBitFile;     FOut.CloseBitFile;
  ShowMessage('  .');
  Gauge1.Progress:=0;
 Except on EFileBitZacr do
       ShowMessage('   .');     end;
       {  ,     }
 for J := 1 to ZnSk do KoderMass[J].Free;
 Gauge1.Visible := False;
end;

procedure TMainForm.miHelpClick(Sender: TObject);
begin   {     }
 BitBtn3.Click;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin    {       }
 if ParamCount > 0 then Edit2.Text:=ParamStr(1);
 if ParamCount > 1 then Edit3.Text:=ParamStr(2);
 OpenDialog1.InitialDir := ParamStr(0);
 ZnSk := 2;    ChislSk := 1;
      {     ,   }
  FIn := TBitFile.Create;
  FOut := TBitFile.Create;
  Registr := TStr_Bit.Create;
end;

procedure TMainForm.EdMatrExit(Sender: TObject);
 {       
     }
Var  S : String;  Kode : Integer;
  procedure ShowError(Soob : String);
  begin    {          }
   ShowMessage(Soob);
   EdMatr.SetFocus;
  end;
begin  //     
  ZnSk := 0;          ChislSk := 0;
  S:=Copy(EdMatr.Text,1,Pos('/',EdMatr.Text)-1);
{$R-}
  Val(S,ChislSk, Kode);  //   
  If (Kode <> 0) or (ChislSk>16) or (ChislSk<1)
    then ShowError('    .');
  S:=Copy(EdMatr.Text,Pos('/',EdMatr.Text)+1,Length(EdMatr.Text));
  Val(S,ZnSk, Kode);  //   
{$R+}
  If (Kode <> 0) or (ZnSk>16) or (ZnSk<2) or (ZnSk <= ChislSk)
    then ShowError('    .');
end;

end.
