{------------------------------------------------------------------------------
  TSrvCtrl v2.1 Demo application
 ------------------------------------------------------------------------------
  v1.0:
  Copyright 2002 on TMEDIA, Dettelbachstr. 2,
  D-78315 Radolfzell, info@tmedia.de

  v2.x, based on the original component:
  Copyright 2002 by GSC
  info@gsc.hu

  FREE for non commercial use
 ------------------------------------------------------------------------------}
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, ComCtrls, ExtCtrls, SrvCtrl, StdCtrls, Buttons, ImgList,
  ToolWin;

type
  TMainForm = class(TForm)
    MM: TMainMenu;
    miDatabase: TMenuItem;
    ActionList: TActionList;
    Connect: TAction;
    Disconnect: TAction;
    StartCont: TAction;
    Stop: TAction;
    Pause: TAction;
    Interrogate: TAction;
    Delete: TAction;
    Lock: TAction;
    Unlock: TAction;
    StartAccount: TAction;
    miService: TMenuItem;
    miConnect: TMenuItem;
    miDisconnect: TMenuItem;
    N1: TMenuItem;
    miLock: TMenuItem;
    miUnlock: TMenuItem;
    N2: TMenuItem;
    miExit: TMenuItem;
    miStartContinue: TMenuItem;
    miStop: TMenuItem;
    miPause: TMenuItem;
    N3: TMenuItem;
    miInterrogate: TMenuItem;
    miDelete: TMenuItem;
    N4: TMenuItem;
    miSetupstartaccount: TMenuItem;
    ServiceList: TListView;
    Splitter: TSplitter;
    SrvCtrl: TSrvCtrl;
    VerifyActions: TAction;
    N5: TMenuItem;
    miVerifyactions: TMenuItem;
    SB: TStatusBar;
    ConnPanel: TPanel;
    Panel1: TPanel;
    GoWebBtn: TSpeedButton;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    Images: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    Save: TAction;
    About: TAction;
    miHelp: TMenuItem;
    miAbout: TMenuItem;
    Panel2: TPanel;
    PC: TPageControl;
    TabGeneral: TTabSheet;
    Label1: TLabel;
    Label3: TLabel;
    IntName: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    OpenFileBtn: TSpeedButton;
    Label7: TLabel;
    Label8: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    PauseLabel: TLabel;
    StopLabel: TLabel;
    ShutdownLabel: TLabel;
    SrvName: TEdit;
    SrvDesc: TEdit;
    BinPath: TEdit;
    ErrorCtrl: TComboBox;
    LoadOrder: TEdit;
    SrvType: TComboBox;
    SrvTagID: TEdit;
    TabLogin: TTabSheet;
    RBLocal: TRadioButton;
    RBLogin: TRadioButton;
    CBInteract: TCheckBox;
    AccountName: TEdit;
    SetupStartBtn: TButton;
    TabFailure: TTabSheet;
    TabDependencies: TTabSheet;
    Label9: TLabel;
    SrvDepend: TListBox;
    Refresh: TAction;
    ToolButton18: TToolButton;
    Label4: TLabel;
    SrvStartType: TComboBox;
    Label10: TLabel;
    ToolButton19: TToolButton;
    CBSrvType: TComboBox;
    CBSrvState: TComboBox;
    Panel3: TPanel;
    procedure miExitClick(Sender: TObject);
    procedure AppHint(Sender : TObject);
    procedure FormCreate(Sender: TObject);
    procedure SrvCtrlAfterConnect(Sender: TObject);
    procedure VerifyActionsExecute(Sender: TObject);
    procedure SrvCtrlAfterOpen(Sender: TObject);
    procedure DisconnectExecute(Sender: TObject);
    procedure GoWebBtnClick(Sender: TObject);
    procedure StartContExecute(Sender: TObject);
    procedure StopExecute(Sender: TObject);
    procedure PauseExecute(Sender: TObject);
    procedure InterrogateExecute(Sender: TObject);
    procedure DeleteExecute(Sender: TObject);
    procedure ServiceListChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure SrvCtrlAfterStateChange(Sender: TObject);
    procedure AboutExecute(Sender: TObject);
    procedure ConnectExecute(Sender: TObject);
    procedure StartAccountExecute(Sender: TObject);
    procedure SrvNameChange(Sender: TObject);
    procedure RBLocalClick(Sender: TObject);
    procedure RBLoginClick(Sender: TObject);
    procedure SplitterCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure SaveExecute(Sender: TObject);
    procedure RefreshExecute(Sender: TObject);
    procedure CBSrvTypeChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    FLoading : boolean;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses ShellAPI, about, Math, IniFiles;

{$R *.DFM}

const
  ICON_UNKNOWN = -1;
  ICON_RUN     = 0;
  ICON_STOP    = 1;
  ICON_PAUSE   = 2;

procedure TMainForm.AppHint(Sender: TObject);
begin
  // Display hint in status bar
  if Application.Hint = '' then SB.SimpleText := 'Ready.'
                           else SB.SimpleText := Application.Hint;
end;

procedure TMainForm.miExitClick(Sender: TObject);
begin
  // Close main window --> exit application
  Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  Ini : TIniFile;
begin
  Application.OnHint := AppHint;

  Ini := TIniFile.Create(ExtractFilepath(Application.ExeName) + 'srvdemo.ini');
  try
    // Default connect to this computer...
    SrvCtrl.Machine := Ini.ReadString('Options','Machine','localhost');
    // Default filters
    CBSrvType.ItemIndex := Ini.ReadInteger('Options','Type',Integer(lstWin32));
    CBSrvState.ItemIndex := Ini.ReadInteger('Options','State',Integer(lssAll));
  finally
    Ini.Free;
  end;

  // ... and list services
  SrvCtrl.Active := true;

  PC.ActivePageIndex := 0;
end;

procedure TMainForm.SrvCtrlAfterConnect(Sender: TObject);
var
  li : TListItem;
  sl : TStringList;
  i : integer;
begin
  Connect.Enabled := not SrvCtrl.Active;
  Disconnect.Enabled := SrvCtrl.Active;
  Lock.Enabled := Disconnect.Enabled;
  Unlock.Enabled := false;
  Refresh.Enabled := Disconnect.Enabled;
  // If you close the form components shouldn't be moified or an exception is raised!!!
  if Visible then
    begin
      CBSrvType.Enabled := Disconnect.Enabled;
      CBSrvState.Enabled := Disconnect.Enabled;
    end;

  StartCont.Enabled := false;
  Stop.Enabled := false;
  Pause.Enabled := false;
  Interrogate.Enabled := false;
  Delete.Enabled := false;
  StartAccount.Enabled := false;
  VerifyActions.Enabled := false;

  if SrvCtrl.Active then
    begin
      ConnPanel.Caption := 'Connected to: ' + SrvCtrl.Machine;

      sl := TStringList.Create;
      FLoading := true;
      SB.SimpleText := 'Loading services...';
      try
        ServiceList.Items.BeginUpdate;
        // Get service list
        SrvCtrl.ListServices(sl,TListServiceType(CBSrvType.ItemIndex),TListServiceState(CBSrvState.ItemIndex),true,rfAll);
        for i := 0 to sl.Count - 1 do
          begin
            Application.ProcessMessages;
            // Make a listitem for every service found
            li := ServiceList.Items.Add;
            li.Caption := sl.Values[sl.Names[i]];
            // Open service to get additional information about it
            SrvCtrl.KeyName := sl.Names[i];
            Application.ProcessMessages;
            li.SubItems.Add(SrvCtrl.Description);
            // Get running state to select the icon for the listitem
            case SrvCtrl.GetRunState of
              srtStopPending,
              srtContinuePending,
              srtStopped : begin
                             li.SubItems.Add('Stopped');
                             li.ImageIndex := ICON_STOP;
                           end;
              srtStartPending,
              srtRunning : begin
                             li.SubItems.Add('Running');
                             li.ImageIndex := ICON_RUN;
                           end;
              srtPausePending,
              srtPaused : begin
                            li.SubItems.Add('Paused');
                            li.ImageIndex := ICON_PAUSE;
                          end;
              else
                begin
                  li.SubItems.Add('Unknown');
                  li.ImageIndex := ICON_UNKNOWN;
                end;
            end;
            Application.ProcessMessages;
            li.SubItems.Add(sl.Names[i]);
          end;
      finally
        sl.Free;
        FLoading := false;
        SB.SimpleText := 'Ready.';
        ServiceList.Items.EndUpdate;
      end;

      ServiceList.Selected := nil;
    end
    else
    begin
      if Visible then
        begin
          // If connection is closed clear the listview and display notify message
          ServiceList.Items.Clear;
          ConnPanel.Caption := 'Not connected';
        end;
    end;
end;

procedure TMainForm.VerifyActionsExecute(Sender: TObject);
begin
  // Setup weater to check Start, Stop, Pause, etc. operations weather they run successfull
  SrvCtrl.VerifyAction := not SrvCtrl.VerifyAction;
  VerifyActions.Checked := SrvCtrl.VerifyAction;
end;

procedure TMainForm.SrvCtrlAfterOpen(Sender: TObject);
var
  i : integer;
begin
  if not Visible then
    exit;
    
  // Update toolbar buttons and menuitems
  StartCont.Enabled := (SrvCtrl.Service > 0) and not (SrvCtrl.InRunState(srtRunning));
  Stop.Enabled := (SrvCtrl.Service > 0) and (SrvCtrl.AcceptControl(caStop)) and not (SrvCtrl.InRunState(srtStopped));
  Pause.Enabled := (SrvCtrl.Service > 0) and (SrvCtrl.AcceptControl(caPauseCont)) and not (SrvCtrl.InRunState(srtPaused));
  Interrogate.Enabled := (SrvCtrl.Service > 0) and (SrvCtrl.InRunState(srtRunning));
  Delete.Enabled := SrvCtrl.Service > 0;
  StartAccount.Enabled := SrvCtrl.Service > 0;
  VerifyActions.Enabled := SrvCtrl.Service > 0;

  if (not FLoading) and Assigned(ServiceList.Selected) then
    begin
      if (SrvCtrl.Service > 0) then
        begin
          with SrvCtrl do
            begin
              // Display all information avaiable
              SrvName.Text := DisplayName;
              IntName.Caption := KeyName;
              SrvStartType.ItemIndex := Integer(StartType) - 2;
              PauseLabel.Enabled := AcceptControl(caPauseCont);
              StopLabel.Enabled := AcceptControl(caStop);
              ShutdownLabel.Enabled := AcceptControl(caShutdown);
              SrvDesc.Text := Description;
              BinPath.Text := BinaryPathName;
              OpenFileBtn.Enabled := true;
              // ServiceType is not an incremental value but the power of 2
              // Convert it to an incremental value
              SrvType.ItemIndex := Round(Ln(ServiceType and (not stInteractive))/Ln(2));
              SrvTagID.Text := IntToStr(TagID);
              ErrorCtrl.ItemIndex := Integer(ErrorControl);
              LoadOrder.Text := LoadOrderGroup;
              AccountName.Text := ServiceStartName;
              if AccountName.Text = SLocalSystem then RBLocal.Checked := true
                                                 else RBLogin.Checked := true;
              CBInteract.Checked := (ServiceType and stInteractive) = stInteractive;
              SrvDepend.Items.Clear;
              SrvDepend.Items.AddStrings(Dependencies);
              for i := 0 to SrvDepend.Items.Count - 1 do
                if IsGroupName(SrvDepend.Items[i]) then SrvDepend.Items[i] := StringReplace(SrvDepend.Items[i],SGroupID,'(group) ',[rfIgnoreCase])
                                                   else SrvDepend.Items[i] := KeyNameToDisplayName(SrvDepend.Items[i]);
              case GetRunState of
                srtStopPending,
                srtContinuePending,
                srtStopped : begin
                                 begin
                                   ServiceList.Selected.SubItems.Add('Stopped');
                                   ServiceList.Selected.ImageIndex := ICON_STOP;
                                 end;
                             end;
                srtStartPending,
                srtRunning : begin
                               ServiceList.Selected.SubItems.Add('Running');
                               ServiceList.Selected.ImageIndex := ICON_RUN;
                             end;
                srtPausePending,
                srtPaused : begin
                              ServiceList.Selected.SubItems.Add('Paused');
                              ServiceList.Selected.ImageIndex := ICON_PAUSE;
                            end;
                else
                  begin
                    ServiceList.Selected.SubItems.Add('Unknown');
                    ServiceList.Selected.ImageIndex := ICON_UNKNOWN;
                  end;
              end;
            end;
        end;

      // All controls tag property hold 0 if they aren't modified and 1 if they are
      // Reset this values to 0
      PC.Visible := SrvCtrl.Service > 0;
      for i := 0 to TabGeneral.ControlCount - 1 do
        if (TabGeneral.Controls[i] is TWinControl) then
          TWinControl(TabGeneral.Controls[i]).Tag := 0;
    end;

  Save.Enabled := false;
end;

procedure TMainForm.DisconnectExecute(Sender: TObject);
begin
  // Disconnect from SCM
  SrvCtrl.Active := false;
end;

procedure TMainForm.GoWebBtnClick(Sender: TObject);
begin
  ShellExecute(handle,'open','http://www.gsc.hu','','',SW_SHOWNORMAL);
end;

procedure TMainForm.StartContExecute(Sender: TObject);
begin
  // Prevent user from selecting an other item while process
  ServiceList.Enabled := false;
  try
    if SrvCtrl.InRunState(srtPaused) then SrvCtrl.Continue
                                     else SrvCtrl.Start;
  finally
    ServiceList.Enabled := true;
  end;
end;

procedure TMainForm.StopExecute(Sender: TObject);
begin
  // Prevent user from selecting an other item while process
  ServiceList.Enabled := false;
  try
    SrvCtrl.Stop;
  finally
    ServiceList.Enabled := true;
  end;
end;

procedure TMainForm.PauseExecute(Sender: TObject);
begin
  // Prevent user from selecting an other item while process
  ServiceList.Enabled := false;
  try
    SrvCtrl.Pause;
  finally
    ServiceList.Enabled := true;
  end;
end;

procedure TMainForm.InterrogateExecute(Sender: TObject);
begin
  // Prevent user from selecting an other item while process
  ServiceList.Enabled := false;
  try
    SrvCtrl.Interrogate;
  finally
    ServiceList.Enabled := true;
  end;
end;

procedure TMainForm.DeleteExecute(Sender: TObject);
begin
  if MessageDlg('Do you realy want to mark this service for deletion?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
    begin
      // Prevent user from selecting an other item while process
      ServiceList.Enabled := false;
      try
        SrvCtrl.Delete;
      finally
        ServiceList.Enabled := true;
      end;
    end;
end;

procedure TMainForm.ServiceListChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  if Change = ctState then
    // If user selected an item then display it...
    if Item.Selected then SrvCtrl.KeyName := Item.SubItems[2]
                     else if SrvCtrl.Service > 0 then
                     // ... else close the current service
                       SrvCtrl.CloseService;
end;

procedure TMainForm.SrvCtrlAfterStateChange(Sender: TObject);
begin
  if not Assigned(ServiceList.Selected) then
    exit;
    
  // Respond state change
  case SrvCtrl.GetRunState of
    srtStopPending,
    srtContinuePending,
    srtStopped : begin
                   ServiceList.Selected.SubItems[1] := 'Stopped';
                   ServiceList.Selected.ImageIndex := ICON_STOP;
                 end;
    srtStartPending,
    srtRunning : begin
                   ServiceList.Selected.SubItems[1] := 'Running';
                   ServiceList.Selected.ImageIndex := ICON_RUN;
                 end;
    srtPausePending,
    srtPaused : begin
                  ServiceList.Selected.SubItems[1] := 'Paused';
                  ServiceList.Selected.ImageIndex := ICON_PAUSE;
                end;
    else
       begin
         ServiceList.Selected.SubItems[1] := 'Unknown';
         ServiceList.Selected.ImageIndex := ICON_UNKNOWN;
       end;
  end;

  // Refresh data in listview
  ServiceListChange(ServiceList,ServiceList.Selected,ctState);
end;

procedure TMainForm.AboutExecute(Sender: TObject);
begin
  with TAboutForm.Create(Self) do
    begin
      try
        ShowModal;
      finally
        Release;
      end;
    end;
end;

procedure TMainForm.ConnectExecute(Sender: TObject);
var
  s : string;
begin
  // Default connect to localhost
  s := 'localhost';
  // Query from user the computername
  if InputQuery('Connect to computer','Please enter the name of the computer:',s) then
    begin
      SrvCtrl.Active := false;
      SrvCtrl.Machine := s;
      SrvCtrl.KeyName := '';
      // Connect to SCM
      SrvCtrl.Active := true;
    end;
end;

procedure TMainForm.StartAccountExecute(Sender: TObject);
var
  username, pwd1, pwd2 : string;
begin
  if MessageDlg('Changing startup information could cause to fail the service next time you start it!'#10#10+
                'Continue away?',mtWarning,[mbYes,mbNo],0) = mrNo then
    exit;

  // Display info to user how to define usernames
  MessageDlg('Use an account name in the form DomainName\UserName!'#10+
             'If the account belongs to the built-in domain, you can specify .\UserName!',mtInformation,[mbOK],0);

  if AccountName.Text = SLocalSystem then username := ''
                                     else username := AccountName.Text;
  pwd1 := '';
  pwd2 := '';

  if InputQuery('Startup account','Enter startup account name (empty for LocalSystem)',username) then
    begin
      if username = '' then
          username := SLocalSystem
        else
          // Get password if user is not LocalSystem
          if InputQuery('Startup account','Enter the password of ' + QuotedStr(username), pwd1) then
            if InputQuery('Startup account','Enter the password of ' + QuotedStr(username) + ' again', pwd2) then
              if pwd1 <> pwd2 then
                begin
                  MessageDlg('The passwords are different!',mtError,[mbOK],0);
                  exit;
                end;

      if MessageDlg('Startup account will be changed to ' + QuotedStr(username) + #10#10+
                    'Would you like to continue?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
        begin
          // Change startup account
          SrvCtrl.SetupStartAccount(username,pwd1);
          MessageDlg('Startup account changed!',mtInformation,[mbOK],0);
          // If the service is running then it must be restarted to take changes in effect
          if SrvCtrl.InRunState(srtRunning) then
            MessageDlg('Service is running!'#10#10+
                       'To take changes in effect you have to restart it!',mtInformation,[mbOK],0);
          SrvCtrlAfterOpen(SrvCtrl);
        end;
    end;
end;

procedure TMainForm.SrvNameChange(Sender: TObject);
begin
  // This event handler is connected to all controls to save weather their contents are changed
  TWinControl(Sender).Tag := 1;
  Save.Enabled := true;
end;

procedure TMainForm.RBLocalClick(Sender: TObject);
begin
  CBInteract.Enabled := true;
  AccountName.Enabled := false;
  AccountName.Color := clBtnFace;
end;

procedure TMainForm.RBLoginClick(Sender: TObject);
begin
  CBInteract.Enabled := false;
  AccountName.Enabled := true;
  AccountName.Color := clWindow;
end;

procedure TMainForm.SplitterCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  // Avoid splitter to resize to a size witch hides a part from PageControl
  Accept := NewSize >= 216;
end;

procedure TMainForm.SaveExecute(Sender: TObject);
begin
  ServiceList.Enabled := false;
  SB.SimpleText := 'Saving changes to SCM...';
  Application.ProcessMessages;
  try
    // Save changes by filling the properties 
    if SrvName.Tag > 0 then
      SrvCtrl.DisplayName := SrvName.Text;

    if SrvStartType.Tag > 0 then
      SrvCtrl.StartType := TSrvStartType(SrvStartType.ItemIndex + 2);

    if SrvDesc.Tag > 0 then
      SrvCtrl.Description := SrvDesc.Text;

    if BinPath.Tag > 0 then
      SrvCtrl.BinaryPathName := BinPath.Text;

    if SrvType.Tag > 0 then
      if CBInteract.Checked then
          SrvCtrl.ServiceType := Round(Power(2,SrvType.ItemIndex)) and stInteractive
        else
          SrvCtrl.ServiceType := Round(Power(2,SrvType.ItemIndex));

    if SrvTagID.Tag > 0 then
      SrvCtrl.TagId := StrToIntDef(SrvTagID.Text,0);

    if ErrorCtrl.Tag > 0 then
      SrvCtrl.ErrorControl := TSrvErrorCtrl(ErrorCtrl.ItemIndex);

    if LoadOrder.Tag > 0 then
      SrvCtrl.LoadOrderGroup := LoadOrder.Text;

    MessageDlg('Changes saved to SCM!',mtInformation,[mbOK],0);

    // If the service is running then it must be restarted to take changes in effect
    if SrvCtrl.InRunState(srtRunning) then
      MessageDlg('To take changes in effect you have to restart the service!',mtInformation,[mbOK],0);

    SrvCtrlAfterOpen(SrvCtrl);
  finally
    SB.SimpleText := 'Ready.';
    ServiceList.Enabled := true;
    Save.Enabled := false;
  end;
end;

procedure TMainForm.RefreshExecute(Sender: TObject);
var
  temp : string;
  li : TListItem;
begin
  temp := '';
  // Save selected item to select it after refresh
  if Assigned(ServiceList.Selected) then
    temp := ServiceList.Selected.SubItems[2];

  // Disconnect and then connect to SCM
  SrvCtrl.Active := false;
  SrvCtrl.Active := true;

  if temp <> '' then
    begin
      // Try to find the previous selected item...
      li := ServiceList.FindCaption(0,SrvCtrl.KeyNameToDisplayName(temp),false,true,false);
      if Assigned(li) then
        begin
          // ... and select it
          li.Selected := true;
          li.Focused := true;
          li.MakeVisible(false);
        end;
    end;

  ServiceList.SetFocus;
end;

procedure TMainForm.CBSrvTypeChange(Sender: TObject);
begin
  // Refresh list after filter change
  Refresh.Execute;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Ini : TIniFile;
begin
  Ini := TIniFile.Create(ExtractFilepath(Application.ExeName) + 'srvdemo.ini');
  try
    Ini.WriteString('Options','Machine',SrvCtrl.Machine);
    Ini.WriteInteger('Options','Type',CBSrvType.ItemIndex);
    Ini.WriteInteger('Options','State',CBSrvState.ItemIndex);
  finally
    Ini.Free;
  end;
end;

end.
