{********************************************************}
{                                                        }
{                      DrawX                             }
{             IMPORTANT-READ CAREFULLY:                  }
{                                                        }
{    This End-User License Agreement is a legal          }
{    agreement between you (either an individual         }
{    or a single entity) and Pisarev Yuriy for           }
{    the software product identified above, which        }
{    includes computer software and may include          }
{    associated media, printed materials, and "online"   }
{    or electronic documentation ("SOFTWARE PRODUCT").   }
{    By installing, copying, or otherwise using the      }
{    SOFTWARE PRODUCT, you agree to be bound by the      }
{    terms of this LICENSE AGREEMENT.                    }
{                                                        }
{    If you do not agree to the terms of this            }
{    LICENSE AGREEMENT, do not install or use            }
{    the SOFTWARE PRODUCT.                               }
{                                                        }
{    License conditions                                  }
{                                                        }
{    No part of the software or the manual may be        }
{    multiplied, disseminated or processed in any        }
{    way without the written consent of Pisarev          }
{    Yuriy. Violations of these conditions will be       }
{    prosecuted in every case.                           }
{                                                        }
{    The use of the software is done at your own         }
{    risk. The manufacturer and developer accepts        }
{    no liability for any damages, either as direct      }
{    or indirect consequence of the use of this          }
{    product or software.                                }
{                                                        }
{    Only observance of these conditions allows you      }
{    to use the hardware and software in your computer   }
{    system.                                             }
{                                                        }
{    All rights reserved.                                }
{    Copyright 2002 Pisarev Yuriy                        }
{                                                        }
{                 yuriy_mbox@hotmail.com                 }
{                                                        }
{********************************************************}

unit DrawImpl;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, AxCtrls, XDraw_TLB, StdVcl, ComCtrls, ExtCtrls, ImgList,
  ActnList, ActnMan, ToolWin, Menus, PicBldr, StdCtrls;

type
  TDrawX = class(TActiveForm, IDrawX)
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ActionManager1: TActionManager;
    EditStart: TAction;
    EditStop: TAction;
    ImageList1: TImageList;
    Timer: TTimer;
    ProgressBar: TProgressBar;
    Memo: TMemo;
    Splitter1: TSplitter;
    Panel1: TPanel;
    PicBldr: TPicBldr;
    procedure EditStartExecute(Sender: TObject);
    procedure EditStopExecute(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure PicBldrConstruct(Sender: TObject);
    procedure PicBldrConstructing(Sender: TObject; Done: Integer);
  private
    FEvents: IDrawXEvents;
    FTotal: Integer;
    procedure ActivateEvent(Sender: TObject);
    procedure ClickEvent(Sender: TObject);
    procedure CreateEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure DeactivateEvent(Sender: TObject);
    procedure DestroyEvent(Sender: TObject);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure PaintEvent(Sender: TObject);
  protected
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    function Get_Active: WordBool; safecall;
    function Get_AlignDisabled: WordBool; safecall;
    function Get_AutoScroll: WordBool; safecall;
    function Get_AutoSize: WordBool; safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_Color: OLE_COLOR; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_DropTarget: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Font: IFontDisp; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_HelpKeyword: WideString; safecall;
    function Get_HelpType: TxHelpType; safecall;
    function Get_KeyPreview: WordBool; safecall;
    function Get_PixelsPerInch: Integer; safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    function Get_Scaled: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    procedure _Set_Font(var Value: IFontDisp); safecall;
    procedure AboutBox; safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    procedure Set_AutoSize(Value: WordBool); safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(const Value: IFontDisp); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_HelpKeyword(const Value: WideString); safecall;
    procedure Set_HelpType(Value: TxHelpType); safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    function Get_Lines: IStrings; safecall;
    procedure Set_Lines(const Value: IStrings); safecall;
    procedure Draw; safecall;
  public
    procedure Initialize; override;
    property Total: Integer read FTotal write FTotal;
  end;

implementation

uses ComObj, ComServ, About;

{$R *.DFM}

{ TDrawX }

procedure TDrawX.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  { Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_DrawXPage); }
end;

procedure TDrawX.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IDrawXEvents;
  inherited EventSinkChanged(EventSink);
end;

procedure TDrawX.Initialize;
begin
  inherited Initialize;
  OnActivate := ActivateEvent;
  OnClick := ClickEvent;
  OnCreate := CreateEvent;
  OnDblClick := DblClickEvent;
  OnDeactivate := DeactivateEvent;
  OnDestroy := DestroyEvent;
  OnKeyPress := KeyPressEvent;
  OnPaint := PaintEvent;
  PicBldr.CalcScripts;
end;

function TDrawX.Get_Active: WordBool;
begin
  Result := Active;
end;

function TDrawX.Get_AlignDisabled: WordBool;
begin
  Result := AlignDisabled;
end;

function TDrawX.Get_AutoScroll: WordBool;
begin
  Result := AutoScroll;
end;

function TDrawX.Get_AutoSize: WordBool;
begin
  Result := AutoSize;
end;

function TDrawX.Get_AxBorderStyle: TxActiveFormBorderStyle;
begin
  Result := Ord(AxBorderStyle);
end;

function TDrawX.Get_Caption: WideString;
begin
  Result := WideString(Caption);
end;

function TDrawX.Get_Color: OLE_COLOR;
begin
  Result := OLE_COLOR(Color);
end;

function TDrawX.Get_Cursor: Smallint;
begin
  Result := Smallint(Cursor);
end;

function TDrawX.Get_DoubleBuffered: WordBool;
begin
  Result := DoubleBuffered;
end;

function TDrawX.Get_DropTarget: WordBool;
begin
  Result := DropTarget;
end;

function TDrawX.Get_Enabled: WordBool;
begin
  Result := Enabled;
end;

function TDrawX.Get_Font: IFontDisp;
begin
  GetOleFont(Font, Result);
end;

function TDrawX.Get_HelpFile: WideString;
begin
  Result := WideString(HelpFile);
end;

function TDrawX.Get_HelpKeyword: WideString;
begin
  Result := WideString(HelpKeyword);
end;

function TDrawX.Get_HelpType: TxHelpType;
begin
  Result := Ord(HelpType);
end;

function TDrawX.Get_KeyPreview: WordBool;
begin
  Result := KeyPreview;
end;

function TDrawX.Get_PixelsPerInch: Integer;
begin
  Result := PixelsPerInch;
end;

function TDrawX.Get_PrintScale: TxPrintScale;
begin
  Result := Ord(PrintScale);
end;

function TDrawX.Get_Scaled: WordBool;
begin
  Result := Scaled;
end;

function TDrawX.Get_Visible: WordBool;
begin
  Result := Visible;
end;

function TDrawX.Get_VisibleDockClientCount: Integer;
begin
  Result := VisibleDockClientCount;
end;

procedure TDrawX._Set_Font(var Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TDrawX.AboutBox;
begin
  ShowDrawXAbout;
end;

procedure TDrawX.ActivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnActivate;
end;

procedure TDrawX.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TDrawX.CreateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnCreate;
end;

procedure TDrawX.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TDrawX.DeactivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDeactivate;
end;

procedure TDrawX.DestroyEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDestroy;
end;

procedure TDrawX.KeyPressEvent(Sender: TObject; var Key: Char);
var
  TempKey: Smallint;
begin
  TempKey := Smallint(Key);
  if FEvents <> nil then FEvents.OnKeyPress(TempKey);
  Key := Char(TempKey);
end;

procedure TDrawX.PaintEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnPaint;
end;

procedure TDrawX.Set_AutoScroll(Value: WordBool);
begin
  AutoScroll := Value;
end;

procedure TDrawX.Set_AutoSize(Value: WordBool);
begin
  AutoSize := Value;
end;

procedure TDrawX.Set_AxBorderStyle(Value: TxActiveFormBorderStyle);
begin
  AxBorderStyle := TActiveFormBorderStyle(Value);
end;

procedure TDrawX.Set_Caption(const Value: WideString);
begin
  Caption := TCaption(Value);
end;

procedure TDrawX.Set_Color(Value: OLE_COLOR);
begin
  Color := TColor(Value);
end;

procedure TDrawX.Set_Cursor(Value: Smallint);
begin
  Cursor := TCursor(Value);
end;

procedure TDrawX.Set_DoubleBuffered(Value: WordBool);
begin
  DoubleBuffered := Value;
end;

procedure TDrawX.Set_DropTarget(Value: WordBool);
begin
  DropTarget := Value;
end;

procedure TDrawX.Set_Enabled(Value: WordBool);
begin
  Enabled := Value;
end;

procedure TDrawX.Set_Font(const Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TDrawX.Set_HelpFile(const Value: WideString);
begin
  HelpFile := String(Value);
end;

procedure TDrawX.Set_HelpKeyword(const Value: WideString);
begin
  HelpKeyword := String(Value);
end;

procedure TDrawX.Set_HelpType(Value: TxHelpType);
begin
  HelpType := THelpType(Value);
end;

procedure TDrawX.Set_KeyPreview(Value: WordBool);
begin
  KeyPreview := Value;
end;

procedure TDrawX.Set_PixelsPerInch(Value: Integer);
begin
  PixelsPerInch := Value;
end;

procedure TDrawX.Set_PrintScale(Value: TxPrintScale);
begin
  PrintScale := TPrintScale(Value);
end;

procedure TDrawX.Set_Scaled(Value: WordBool);
begin
  Scaled := Value;
end;

procedure TDrawX.Set_Visible(Value: WordBool);
begin
  Visible := Value;
end;

function TDrawX.Get_Lines: IStrings;
begin
  GetOleStrings(Memo.Lines, Result);
end;

procedure TDrawX.Set_Lines(const Value: IStrings);
begin
  SetOleStrings(Memo.Lines, Value);
end;

procedure TDrawX.Draw;
begin
  PicBldr.Draw;
end;

procedure TDrawX.EditStartExecute(Sender: TObject);
begin
  EditStart.Enabled := False;
  EditStop.Enabled := True;
  with PicBldr do begin
    Lines.Assign(Memo.Lines);
    CalcScripts;
  end;
  Timer.Interval := 1000;
  TimerTimer(nil);
end;

procedure TDrawX.EditStopExecute(Sender: TObject);
begin
  Timer.Interval := 0;
  EditStop.Enabled := False;
  EditStart.Enabled := True;
end;

procedure TDrawX.TimerTimer(Sender: TObject);
begin
  Timer.Enabled := False;
  try
    with PicBldr do begin
      Construct;
      Draw;
    end;
  finally
    if Timer.Interval > 0 then Timer.Enabled := True;
  end;
end;

procedure TDrawX.PicBldrConstruct(Sender: TObject);
begin
  FTotal := PicBldr.PictureSize;
end;

procedure TDrawX.PicBldrConstructing(Sender: TObject; Done: Integer);
var
  Index: Integer;
begin
  Application.ProcessMessages;
  Index := Done * 100 div FTotal;
  if Index >= 100 then ProgressBar.Position := 0
  else if Index >= 95 then ProgressBar.Position := Index
  else if Index mod 5 = 0 then ProgressBar.Position := Index
end;

initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TDrawX,
    Class_DrawX,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.
