unit UFlxMessages;

interface
uses Sysutils,
    {$IFDEF ConditionalExpressions}{$if CompilerVersion >= 14} variants,{$IFEND}{$ENDIF} //Delphi 6 or above
     Windows;
resourcestring
  FieldStr='##';
  DataSetStr='__';
  VarStr='#.';
  MarkedRowStr='...delete row...';
  FullDataSetStr='*';

{$IFDEF SPANISH}
  ErrNoAdapter='No hay un Adaptador asociado al reporte';
  ErrTooManySheets='Se estn intentando crear demasiadas pginas';

  ErrNoDataSet='No se puede encontrar el dataset %s';
  ErrNoPropDefined='No se ha definido la propiedad "%s" o no es published';
  ErrBadProp='Error al recuperar la propiedad "%s". Verifique que sea del tipo variant';
  ErrTooManyDimensions='La propiedad "s" solo tiene %d dimensiones';
  ErrIndexOutBounds='El indice "%d" de la propiedad "%s" no est en el rango %d-%d';

  ErrInvalidDrawingType='El tipo de imagen "%s" no es vlido';

  ErrNoOpenFile='No hay ningun archivo abierto';
  ErrCantWriteToFile='No se puede grabar en el archivo "%s". Compruebe que no este siendo usado por otro usuario'
{$ELSE}
  ErrNoAdapter='There is no Adapter linked to the report';
  ErrTooManySheets='Trying to insert more sheets than the maximum allowed';

  ErrNoDataSet='Cant find the dataset %s';
  ErrNoPropDefined='Property "%s" has not been defined or is not published';
  ErrBadProp='Error trying to retrieve property "%s". Verify it is a variant';
  ErrTooManyDimensions='The property "%s" has only %d dimensions';
  ErrIndexOutBounds='The index "%d" of the property "%s" is not in the range %d-%d';

  ErrInvalidDrawingType='Drawing type "%s" invalid';

  ErrNoOpenFile='There is no open file';
  ErrCantFindFile='Can''t find the file "%s"';
{$ENDIF}

  xls_Emf='EMF';
  xls_Wmf='WMF';
  xls_Jpeg='JPEG';
  xls_Png='PNG';

type
  TOnGetFileNameEvent = procedure (Sender: TObject; const  FileFormat: integer; var Filename: TFileName) of object;
  TXlsImgTypes = (xli_Emf, xli_Wmf, xli_Jpeg, xli_Png);

  VariantArray=Array [0..maxint div sizeof(Variant)-1]of variant;

  TXlsCellValue= record
    Value: variant;
    XF: integer;
    IsFormula: boolean;
  end;

  function SearchPathStr(const AFileName: String): String;

implementation

function SearchPathStr(const AFileName: String): String;
var
  FilePart: PChar;
begin
  SetLength(Result, MAX_PATH + 1);

  if SearchPath(nil, PChar(AFileName), '.xls',
                MAX_PATH, PChar(Result), FilePart) <> 0 then
  begin
    SetLength(Result, Length(PChar(Result)));
  end
  else
    Raise Exception.CreateFmt(ErrCantFindFile,[AFileName]);
end; // SearchRecStr




end.






