{********************************************************}
{                                                        }
{                      Graph                             }
{             IMPORTANT-READ CAREFULLY:                  }
{                                                        }
{    This End-User License Agreement is a legal          }
{    agreement between you (either an individual         }
{    or a single entity) and Pisarev Yuriy for           }
{    the software product identified above, which        }
{    includes computer software and may include          }
{    associated media, printed materials, and "online"   }
{    or electronic documentation ("SOFTWARE PRODUCT").   }
{    By installing, copying, or otherwise using the      }
{    SOFTWARE PRODUCT, you agree to be bound by the      }
{    terms of this LICENSE AGREEMENT.                    }
{                                                        }
{    If you do not agree to the terms of this            }
{    LICENSE AGREEMENT, do not install or use            }
{    the SOFTWARE PRODUCT.                               }
{                                                        }
{    License conditions                                  }
{                                                        }
{    No part of the software or the manual may be        }
{    multiplied, disseminated or processed in any        }
{    way without the written consent of Pisarev          }
{    Yuriy. Violations of these conditions will be       }
{    prosecuted in every case.                           }
{                                                        }
{    The use of the software is done at your own         }
{    risk. The manufacturer and developer accepts        }
{    no liability for any damages, either as direct      }
{    or indirect consequence of the use of this          }
{    product or software.                                }
{                                                        }
{    Only observance of these conditions allows you      }
{    to use the hardware and software in your computer   }
{    system.                                             }
{                                                        }
{    All rights reserved.                                }
{    Copyright 2002 Pisarev Yuriy                        }
{                                                        }
{                 yuriy_mbox@hotmail.com                 }
{                                                        }
{********************************************************}

unit AboutForm;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ShellApi;

type
  TAboutDlg = class(TForm)
    Panel1: TPanel;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    OKButton: TButton;
    Comments: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CommentsClick(Sender: TObject);
    procedure CommentsMouseEnter(Sender: TObject);
    procedure CommentsMouseLeave(Sender: TObject);
  private
    FSaved: TColor;
  end;

var
  AboutDlg: TAboutDlg;

implementation

{$R *.dfm}

procedure TAboutDlg.FormCreate(Sender: TObject);
begin
  FSaved := Comments.Font.Color;
end;

procedure TAboutDlg.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then Close;
end;

procedure TAboutDlg.CommentsClick(Sender: TObject);
var
  Value: string;
begin
  Value := Format('mailto:%s?Subject=Graph; %s',
    [TLabel(Sender).Caption, LowerCase(Version.Caption)]);
  ShellExecute(Handle, 'open', PChar(Value), '', '', SW_SHOWNORMAL);
end;

procedure TAboutDlg.CommentsMouseEnter(Sender: TObject);
begin
  Comments.Font.Color := clRed;
end;

procedure TAboutDlg.CommentsMouseLeave(Sender: TObject);
begin
  Comments.Font.Color := FSaved;
end;

end.
