unit PktDump;
{(C) Alex Demchenko(alex@ritlabs.com)}

interface

uses
  Windows, Messages, Classes, Graphics, Controls, Forms,
  StdCtrls, ComCtrls, ICQWorks;

type
  TPktDumpForm = class(TForm)
    ListView1: TListView;
    Memo1: TMemo;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
  private
  public
    FPktList: TList;
  end;

var
  PktDumpForm: TPktDumpForm;

implementation

{$R *.dfm}

procedure TPktDumpForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caHide;
end;

procedure TPktDumpForm.FormCreate(Sender: TObject);
begin
  FPktList := TList.Create;
end;

procedure TPktDumpForm.FormDestroy(Sender: TObject);
var
  i: Word;
begin
  //Let's free all packets stored in memory
  if FPktList.Count > 0 then
    for i := 0 to FPktList.Count - 1 do
      FreeMem(FPktList.Items[i], SizeOf(TRawPkt));
  FPktList.Free;
end;

procedure TPktDumpForm.ListView1Click(Sender: TObject);
var
  p: PRawPkt;
begin
  if ListView1.Selected = nil then
    Exit;
  p := FPktList.Items[ListView1.Selected.Index];
  Memo1.Text := DumpPacket(p, Swap16(PFlapHdr(p)^.DataLen) + TFLAPSZ);
end;

procedure TPktDumpForm.ListView1SelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  ListView1Click(Sender);
end;

end.
