////////////////////////////////////////////////////////////////////////////////
// Part of Internet EDiting component                                         //
// AUTHOR       : Sergey Kanenko                                              //
// WEBSITE      : http://iedcomp.nm.ru                                        //
////////////////////////////////////////////////////////////////////////////////
//   This code may be used and modified by anyone so long as  this header and //
// copyright  information remains intact.                                     //
//   The code is provided "as-is" and without warranty of any kind,           //
// expressed, implied or otherwise, including and without limitation, any     //
// warranty of merchantability or fitness for a  particular purpose.         //
//   In no event shall the author be liable for any special, incidental,      //
// indirect or consequential damages whatsoever (including, without           //
// limitation, damages for loss of profits, business interruption, loss       //
// of information, or any other loss), whether or not advised of the          //
// possibility of damage, and on any theory of liability, arising out of      //
// or in connection with the use or inability to use this software.         //
////////////////////////////////////////////////////////////////////////////////
unit UnConfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,
  HREFParser;

type
  TfrmConfig = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    edPUserName: TEdit;
    edpPwd: TEdit;
    edPPort: TEdit;
    CheckBox1: TCheckBox;
    UpDown1: TUpDown;
    edLevel: TEdit;
    Label1: TLabel;
    Bevel1: TBevel;
    Button1: TButton;
    Button2: TButton;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    CheckBox20: TCheckBox;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    CheckBox24: TCheckBox;
    CheckBox25: TCheckBox;
    Label5: TLabel;
    edPServer: TEdit;
    edDY: TEdit;
    edDX: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    cbAddNew: TCheckBox;
    UpDown2: TUpDown;
    UpDown3: TUpDown;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure StoreConfig;
    procedure CheckConfig;
  end;

var
  frmConfig: TfrmConfig;

implementation

uses UnMainDiagram, HREFLinker, UnParserShapes;

{$R *.dfm}

{ TfrmConfig }
procedure TfrmConfig.CheckConfig;
begin
 edPUserName.Text  := frmMain.HTTPgate.Request.ProxyUsername;
 edPPwd.Text       := frmMain.HTTPgate.Request.ProxyPassword;
 edPServer.Text    := frmMain.HTTPgate.Request.ProxyServer;
 edPPort.Text      := IntToStr(frmMain.HTTPgate.Request.ProxyPort);
 UpDown1.Position  := frmMain.LNK.MaxParseLevel;
 CheckBox1.Checked := frmMain.LNK.LocalParse;
 cbAddNew.Checked  := frmMain.LNK.AddOnlyNew;
 edDX.Text         := IntToStr(ShapeDeltaX);
 edDY.Text         := IntToStr(ShapeDeltaY);

 CheckBox2.Checked  := (feUnknown in frmMain.LNK.ParseDocument);
 CheckBox3.Checked  := (feRoot in frmMain.LNK.ParseDocument);
 CheckBox4.Checked  := (feHTML in frmMain.LNK.ParseDocument);
 CheckBox9.Checked  := (feCSS in frmMain.LNK.ParseDocument);
 CheckBox10.Checked := (feScript in frmMain.LNK.ParseDocument);
 CheckBox11.Checked := (feASP in frmMain.LNK.ParseDocument);
 CheckBox12.Checked := (fePHP in frmMain.LNK.ParseDocument);
 CheckBox13.Checked := (fePERL in frmMain.LNK.ParseDocument);

 CheckBox14.Checked := (feUnknown in frmMain.LNK.ShowLinks);
 CheckBox15.Checked := (feRoot in frmMain.LNK.ShowLinks);
 CheckBox16.Checked := (feHTML in frmMain.LNK.ShowLinks);
 CheckBox17.Checked := (feIMG in frmMain.LNK.ShowLinks);
 CheckBox18.Checked := (feMEDIA in frmMain.LNK.ShowLinks);
 CheckBox19.Checked := (feJava in frmMain.LNK.ShowLinks);
 CheckBox20.Checked := (feAX in frmMain.LNK.ShowLinks);
 CheckBox21.Checked := (feCSS in frmMain.LNK.ShowLinks);
 CheckBox22.Checked := (feScript in frmMain.LNK.ShowLinks);
 CheckBox23.Checked := (feASP in frmMain.LNK.ShowLinks);
 CheckBox24.Checked := (fePHP in frmMain.LNK.ShowLinks);
 CheckBox25.Checked := (fePERL in frmMain.LNK.ShowLinks);
end;

procedure TfrmConfig.StoreConfig;
begin
 frmMain.HTTPgate.Request.ProxyUsername:= edPUserName.Text;
 frmMain.HTTPgate.Request.ProxyPassword:= edPPwd.Text;
 frmMain.HTTPgate.Request.ProxyServer  := edPServer.Text;
 frmMain.HTTPgate.Request.ProxyPort    := StrToInt(edPPort.Text);
 frmMain.LNK.MaxParseLevel             := UpDown1.Position;
 frmMain.LNK.LocalParse                := CheckBox1.Checked;
 frmMain.LNK.AddOnlyNew                := cbAddNew.Checked;
 ShapeDeltaX                           := StrToInt(edDX.Text);
 ShapeDeltaY                           := StrToInt(edDY.Text);

 with frmMain.LNK do
 begin
  ParseDocument :=[];
  if CheckBox2.Checked  then ParseDocument := [feUnknown] + ParseDocument;
  if CheckBox3.Checked  then ParseDocument := [feRoot] + ParseDocument;
  if CheckBox4.Checked  then ParseDocument := [feHTML] + ParseDocument;
  if CheckBox9.Checked  then ParseDocument := [feCSS] + ParseDocument;
  if CheckBox10.Checked then ParseDocument := [feScript] + ParseDocument;
  if CheckBox11.Checked then ParseDocument := [feASP] + ParseDocument;
  if CheckBox12.Checked then ParseDocument := [fePHP] + ParseDocument;
  if CheckBox13.Checked then ParseDocument := [fePERL] + ParseDocument;
  ShowLinks := [];
  if CheckBox14.Checked then ShowLinks := [feUnknown] + ShowLinks;
  if CheckBox15.Checked then ShowLinks := [feRoot] + ShowLinks;
  if CheckBox16.Checked then ShowLinks := [feHTML] + ShowLinks;
  if CheckBox17.Checked then ShowLinks := [feIMG] + ShowLinks;
  if CheckBox18.Checked then ShowLinks := [feMEDIA] + ShowLinks;
  if CheckBox19.Checked then ShowLinks := [feJava] + ShowLinks;
  if CheckBox20.Checked then ShowLinks := [feAX] + ShowLinks;
  if CheckBox21.Checked then ShowLinks := [feCSS] + ShowLinks;
  if CheckBox22.Checked then ShowLinks := [feScript] + ShowLinks;
  if CheckBox23.Checked then ShowLinks := [feASP] + ShowLinks;
  if CheckBox24.Checked then ShowLinks := [fePHP] + ShowLinks;
  if CheckBox25.Checked then ShowLinks := [fePERL] + ShowLinks;
 end;
end;

procedure TfrmConfig.FormShow(Sender: TObject);
begin
 CheckConfig;
end;

procedure TfrmConfig.Button1Click(Sender: TObject);
begin
 StoreConfig;
end;

end.
