{ ****************************************************************** }
{ Componente VCL TMainMenuXP : Menus tipo Windows XP                 }
{ para instalar : Menu "Component" -> "Install Component"            }
{ Version 1.0 (27/04/2002) escrito por Hugo Lazarte                  }
{ Desarrollo de Software con Codigo Fuente incluido                  }
{ Visual C, Delphi, Assembler(conocimientos de ingenieria de reversa)}
{ hslazarte@softhome.net                                             }
{ www.medicsoft.com.pe                                               }
{ Lima - Peru                                                        }
{                                                                    }
{   Copyright  2002 by Hugo Lazarte                                 }
{   Este componente puede ser usado y redistribuido libremente       }
{   solo si se mantiene los derechos de autor                        }
{   Cualquier sugerencia es bienvenida a mi email                    }
{   Ofrecido "TAL COMO ESTA" --                                      }
{   Probado solo en Delphi 5.0                                       }
{                                                                    }
{                                                                    }
{ ****************************************************************** }

{ ****************************************************************** }
{                                                                    }
{ VCL component TMainMenuXP:  Menus Windows XP type                  }
{ For Install : Menu "Component" -> "Install Component"              }
{ Version 1.0 (27/04/2002) written by Hugo Lazarte                   }
{ Software Development with code source included                     }
{ Visual C, Delphi, Assembler(knowledge engineering of reverse)      }
{ www.medicsoft.com.pe                                               }
{ hslazarte@softhome.net                                             }
{ Lima - Peru                                                        }
{                                                                    }
{   Copyright  2002 by Hugo Lazarte                                 }
{   This file may be redistributed freely only if not altered        }
{   Suggestions are welcome to my email                              }
{   Offered "AS IS" --                                               }
{   only proven in Delphi 5.0                                        }
{ ****************************************************************** }


{ ............. FROM THE INKAS EMPIRE FOR THE WORLD ................ }
{AMA SUA}
{AMA LLULLA}
{AMA QUELLA}




unit MainMenuXP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus;

type
  TMainMenuXP = class(TMainMenu)
  private
    { Private declarations }
    function iDeviceBitsPerPixel: Integer;
    procedure MyUpdateItem(Item:TMenuItem;ItemCanvas:TCanvas;Rect : TRect;State: TOwnerDrawState);
    procedure vPaintItemSelected(ItemCanvas:TCanvas;Rect:TRect);
    procedure vDrawCheckBitmap(ItemCanvas : TCanvas;ItemRect : TRect);
    procedure vPaintBitmap(Item :TMenuItem; ItemCanvas : TCanvas;ItemRect : TRect;State: TOwnerDrawState);
    procedure vRecursiveItem(item : TMenuItem);
    procedure MyOnChange(Sender: TObject; Source: TMenuItem;
          Rebuild: Boolean);
    procedure MyOnAdvancedDrawItem(Sender: TObject; ACanvas: TCanvas;
       ARect: TRect; State: TOwnerDrawState);
    procedure MyOnAdvancedDrawSubItem(Sender: TObject; ACanvas: TCanvas;
           ARect: TRect; State: TOwnerDrawState);
    procedure MyOnMeasureItem(Sender: TObject; ACanvas: TCanvas;
    var Width, Height: Integer);
    procedure vDisableBitmap(MyBitmap: TBitmap);
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    constructor Create(AOwner: TComponent); override;
  end;

procedure Register;

implementation


constructor TMainMenuXP.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  OwnerDraw := True;
  OnChange  := MyOnChange;
end;

procedure TMainMenuXP.MyOnMeasureItem(Sender: TObject; ACanvas: TCanvas;
  var Width, Height: Integer);
begin
  inherited;
  Width := Width + 40;
end;


// esta funcion es llamada cuando el componente MainMenuXP es modificado
// ( agregar o quitar items), recorro todos los items cambiando el evento OnDrawItem
// hacia mi funcion propia

procedure TMainMenuXP.MyOnChange(Sender: TObject; Source: TMenuItem;
          Rebuild: Boolean);
var
  a,b : Integer;
begin
  for a := 0 to items.count-1 do
  begin
    for b := 0 to items[a].count -1 do
    begin
      vRecursiveItem(items[a].items[b]);
    end;

    items[a].OnAdvancedDrawItem := MyOnAdvancedDrawItem;
  end;
end;


// recorrer todos los subitems

procedure TMainMenuXP.vRecursiveItem(item : TMenuItem);
var
 i : Integer;
begin
  item.OnAdvancedDrawItem := MyOnAdvancedDrawSubItem;
  item.OnMeasureItem := MyOnMeasureItem;

  for i := 0 to item.Count-1 do
  begin
     vRecursiveItem(item.Items[i]);
  end;
end;


// pintar un item del Menu Principal

procedure TMainMenuXP.MyOnAdvancedDrawItem(Sender: TObject; ACanvas: TCanvas;
     ARect: TRect; State: TOwnerDrawState);
begin
  inherited;

  if (odDisabled in State) then
     ACanvas.Font.Color := clInactiveCaptionText
  else ACanvas.Font.color := clBlack;

  if (odSelected in State ) then
  begin
    // pintar el marco
    // paint the frame
    vPaintItemSelected(ACanvas,ARect);
  end
  else
  begin
    ACanvas.Brush.Color := clBtnFace;
    ACanvas.FillRect(ARect);
  end;

  Inc(ARect.Left,2);
  MyUpdateItem((Sender As TMenuItem),ACanvas,ARect,State);
end;

procedure TMainMenuXP.vDrawCheckBitmap(ItemCanvas : TCanvas ;ItemRect : TRect);
var
  bmp1 : TBitmap;
begin
  bmp1 := TBitmap.create;
  bmp1.handle := LoadBitmap(0, PChar(OBM_CHECK)); //OBM_CHECK
  bmp1.Transparent := True;
  ItemCanvas.Draw(ItemRect.left,ItemRect.Top,bmp1);
  bmp1.Free;
end;


// obtener el numero de colores retorna : 1=Monocromo, 4=16 colores,8=256 colores,
// 16=True Color 16 bits , 24= true color 24 bits, 32=true color 32 bits
// get number colors
function TMainMenuXP.iDeviceBitsPerPixel: Integer;
var
   DC: HDC;
begin
   DC := GetDC(0);
   try
     Result := GetDeviceCaps(DC, PLANES) * GetDeviceCaps(DC, BITSPIXEL);
   finally
     ReleaseDC(0, DC);
   end;
end;


// dibujar un subitem del Menu Principal
//
procedure TMainMenuXP.MyOnAdvancedDrawSubItem(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; State: TOwnerDrawState);
var
  Rect2 : TRect;
begin
  Rect2 := ARect;

  if (odDisabled in State) then
     ACanvas.Font.Color := clInactiveCaptionText
  else ACanvas.Font.color := clBlack;

  if (odSelected  in State) then
  begin
    // pintar el item seleccionado
    // pain selected item
    vPaintItemSelected(ACanvas,Rect2);
  end
  else
  begin
    // pintar el cuadro de color plomo
    // paint the silver frame color
    Rect2.Right        := Rect2.Left + 20;
    ACanvas.Brush.Color := clBtnFace;
    ACanvas.FillRect(Rect2);
    // pintar la parte de color blanca
    // paint the part of white color
    ACanvas.Brush.Color := clWhite;
    Rect2.Left  := Rect2.Right;
    Rect2.Right := ARect.Right;
    ACanvas.FillRect(Rect2);
  end;

  Inc(ARect.Left,25);
  MyUpdateItem((Sender As TMenuItem),ACanvas,ARect,State);

end;

procedure TMainMenuXP.MyUpdateItem(Item:TMenuItem;ItemCanvas:TCanvas;Rect:TRect;State: TOwnerDrawState);
var
 szItemCaption : String;
 TextRect  : TRect;
begin

  TextRect      := Rect;
  Inc(TextRect.Top);
  szItemCaption := Item.Caption;

  if Item.IsLine then
  begin
    Dec(TextRect.left,5);
    Inc(TextRect.top,3);
    DrawEdge(ItemCanvas.Handle, TextRect, EDGE_ETCHED, BF_TOP);
  end
  else
  begin
    DrawText(ItemCanvas.handle,pchar(szItemCaption),
             StrLen(pchar(szItemCaption)),TextRect,0);//DT_LEFT);

    if (Item.ShortCut <> 0) then
    begin
      Dec(TextRect.Right,10);
      DrawText(ItemCanvas.handle, pchar(ShortCutToText(Item.ShortCut)),
       strlen(pchar(ShortCutToText(Item.ShortCut))),
       TextRect, DT_RIGHT);
    end;
  end;

  // pintar el grafico
  // draw bitmap
  Dec(Rect.left,25);
  vPaintBitmap(Item,ItemCanvas,Rect,State );
end;

procedure TMainMenuXP.vPaintItemSelected(ItemCanvas:TCanvas;Rect:TRect);
begin
  ItemCanvas.Brush.Color := RGB(0,0,128);
  ItemCanvas.FrameRect(Rect);

  if iDeviceBitsPerPixel > 8 then
  begin
    ItemCanvas.Brush.Color := TColor($D8ACB0); // XP menu color
  end
  else
  begin
    ItemCanvas.Brush.Color := clActiveCaption;
    ItemCanvas.Font.color := clWhite;
  end;

  Inc(Rect.Left);Inc(Rect.Top);
  Dec(Rect.Right);Dec(Rect.Bottom);

  ItemCanvas.FillRect(Rect);
end;

// dibujar grafico a la izquierda del texto del item
procedure TMainMenuXP.vPaintBitmap(Item:TMenuItem;ItemCanvas : TCanvas;ItemRect : TRect;State: TOwnerDrawState);
var
  Rect2 : TRect;
  TempBmp : TBitmap;
begin
  if (odSelected in State) then
    SetRect(Rect2,ItemRect.left+1,ItemRect.top+1,ItemRect.Left+16,ItemRect.Bottom-1)
  else   SetRect(Rect2,ItemRect.left+2,ItemRect.top+2,ItemRect.Left+16,ItemRect.Bottom);

  if (Item.Checked) then vDrawCheckBitmap(ItemCanvas,Rect2);

  if (Images <> nil) and
     (Item.ImageIndex <> -1) then
  begin
    Images.GetBitmap(Item.imageIndex,Item.Bitmap);
  end;

  if Item.Bitmap <> nil then
  begin
    Rect2.Right := Rect2.Left + 16;
//    SetBkMode(ItemCanvas.handle,TRANSPARENT);

    TempBmp := TBitmap.Create;
    TempBmp.Assign(Item.Bitmap);

    if (odDisabled in State) then
        vDisableBitmap(TempBmp);

    ItemCanvas.StretchDraw(Rect2, TempBmp);

    TempBmp.Free;
  end;

end;


procedure TMainMenuXP.vDisableBitmap(MyBitmap: TBitmap);
var
  w, h: integer;
  iGrayLevel : integer;
  clColorAnterior, clGrayedColor, clPixelColor: TColor;
begin
  clColorAnterior := 0;
  clGrayedColor := 0;

  for h := 0 to MyBitmap.Height do
    for w := 0 to MyBitmap.Width do
    begin
      clPixelColor := MyBitmap.Canvas.Pixels[w, h];
      if clPixelColor = clColorAnterior then
        MyBitmap.Canvas.Pixels[w, h] := clGrayedColor
      else
      begin
         clPixelColor := ColorToRGB(clPixelColor);
         iGrayLevel := (((clPixelColor and $000000FF) +
                ((clPixelColor and $0000FF00) shr 8) +
                ((clPixelColor and $00FF0000) shr 16)) div 3)+70;

         if iGrayLevel > 230 then iGrayLevel := 230;// no black, only gray

        clGrayedColor := Windows.GetNearestColor(MyBitmap.Canvas.handle,RGB(iGrayLevel, iGrayLevel, iGrayLevel));
        MyBitmap.Canvas.Pixels[w, h] := clGrayedColor;
        clColorAnterior := clPixelColor;
      end;
    end;
end;

procedure Register;
begin
  RegisterComponents('MEDICSOFT', [TMainMenuXP]);
end;

end.
