{***************************************************************************}
{ TAdvStringGrid Print Settings dialog component                            }
{ for Delphi 6.0 & Kylix 1.0,2.0                                            }
{ version 1.0 - rel. Oct 2001                                               }
{                                                                           }
{ written by TMS Software                                                   }
{            copyright  2001                                               }
{            Email : info@tmssoftware.com                                   }
{            Web : http://www.tmssoftware.com                               }
{***************************************************************************}

unit QAsgPrintDlgReg;

interface

uses
  QAsgPrintDlg,QAdvGrid,Classes,QForms,DesignIntf, DesignEditors;


type
  TAdvGridPrintSettingsEditor = class(TComponentEditor)
  public
    function GetVerb(index:integer):string; override;
    function GetVerbCount:integer; override;
    procedure ExecuteVerb(Index:integer); override;
  end;

  TPrintSettingsProperty =class(TClassProperty)
  public
    function GetAttributes:TPropertyAttributes; override;
    procedure Edit; override;
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('TMS Grids', [TAdvGridPrintSettingsDialog]);
  RegisterComponentEditor(TAdvGridPrintSettingsDialog,TAdvGridPrintSettingsEditor);
  RegisterPropertyEditor(TypeInfo(TPrintSettings),TAdvStringGrid,'PrintSettings',TPrintSettingsProperty);
end;


procedure TAdvGridPrintSettingsEditor.ExecuteVerb(Index: integer);
begin
  (component as TAdvGridPrintSettingsDialog).Execute;
end;

function TAdvGridPrintSettingsEditor.GetVerb(index: integer): string;
begin
  Result := '&Execute';
end;

function TAdvGridPrintSettingsEditor.GetVerbCount: integer;
begin
  Result := 1;
end;

{ TPrintSettingsProperty }

procedure TPrintSettingsProperty.Edit;
var
  Grid: TAdvStringGrid;
  Settings: TAdvGridPrintSettingsDialog;
begin
  Grid := TAdvStringGrid(GetComponent(0));
  Settings := TAdvGridPrintSettingsDialog.Create(nil);
  Settings.Grid := Grid;
  Settings.Options := [psBorders,psGeneral,psFonts,psDateTime,psTitle,psPages,psMargins,psSpacing];
  if Settings.Execute then
    Modified;
  Settings.free;
end;

function TPrintSettingsProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;


end.




