unit DateTimeEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, Options;

type
  TdtKind = (dtkDate, dtkTime, dtkDateTime);

  TfrmDateTimeEditor = class(TForm)
    pnlDate: TPanel;
    pnlTime: TPanel;
    pnlButtons: TPanel;
    Label1: TLabel;
    dtpDate: TDateTimePicker;
    dtpTime: TDateTimePicker;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure dtpDateChange(Sender: TObject);
    procedure dtpTimeChange(Sender: TObject);
  private
    FKind: TdtKind;
    FDate: TDateTime;
    FTime: TDateTime;
    procedure SetKind(K: TdtKind);
    procedure SetDate(D: TDateTime);
    procedure SetTime(T: TDateTime);
  public
    property Kind: TdtKind read FKind write SetKind;
    property Date: TDateTime read FDate write SetDate;
    property Time: TDateTime read FTime write SetTime;
  end;

implementation

{$R *.DFM}

{ TfrmDateTimeEditor }

procedure TfrmDateTimeEditor.SetKind(K: TdtKind);
begin
  FKind := K;
  case K of
    dtkDate:
      pnlTime.Visible := false;
    dtkTime: begin
      pnlDate.Visible := false;
      pnlTime.Left := 0;
    end;
  end;
end;

procedure TfrmDateTimeEditor.SetDate(D: TDateTime);
begin
  FDate := int(D);
  dtpDate.Date := FDate;
end;

procedure TfrmDateTimeEditor.SetTime(T: TDateTime);
begin
  FTime := frac(T);
  dtpTime.Time := FTime;
end;

procedure TfrmDateTimeEditor.dtpDateChange(Sender: TObject);
begin
  FDate := int(dtpDate.Date);
end;

procedure TfrmDateTimeEditor.dtpTimeChange(Sender: TObject);
begin
  FTime := frac(dtpTime.Time);
end;

end.

