unit WCButton;
{
************************
**     TWCButton      **
************************
      version 1.1
Version 1.1, 14 Jun 2002


  Wavy, wavy@smtp.ru
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs , extctrls;

const
  Maxize = (1294967280 Div SizeOf(TPoint));
  MaxPixelCount   =  32768;
  Mask0101 = $00FF00FF;
  Mask1010 = $FF00FF00;

var
   tp, lp : integer;               //current caption pitch
   IsStopMorph : Boolean=false;    //stop morph flag
   Count : integer;                //numbrt of buttons
   ActiveNumber : integer;         //number of active button
type
  EWCButton = class(Exception);

  PRGBArray  =  ^TRGBArray;
  TRGBArray  =  array[0..MaxPixelCount-1] of TRGBTriple;

  TPnts = array[0..Maxize - 1] of TPoint;

  TWCButton = class(TGraphicControl)
  private
    {Private Declarations}
    bmF           : TBitmap;  //morphing bitmap from
    bmT           : TBitmap;  //morphing bitmap to
    bmZ           : TBitmap;  //temp morphing bitmap
    FDrawn        : boolean;  //has button been drawn (for first paint)
    FDown         : boolean;
    FPicFrom      : TPicture;
    FPicTo        : TPicture;
    FPicFromDown  : TPicture;
    FPicToDown    : TPicture;
    FGlyph        : TPicture;
    FBRate        : integer;
    FCheck        : boolean;
    FProcMsg      : boolean;
    FOnBegin      : TNotifyEvent;
    FOnEnd        : TNotifyEvent;
    FDelay        : integer;
    FNumber       : integer;  //button number
    FFinish       : Boolean;  //has current morphing finished
    FCaption      : AnsiString;
    FTimer        : TTimer;   //additional update timer
    FFont         : TFont;
    FActiveFont   : TFont;
    FLPitch       : integer;
    FTPitch       : integer;
    FGlyphLPitch  : integer;
    FGlyphTPitch  : integer;
    FGlyphTransCl : TColor;
    FTransCl : TColor;
    FPlain        : Boolean;
    FPitchCaption : Boolean;
    FTransparent  : Boolean;
    FMousePressed : boolean;  //mousepressed state
    FMouseOver    : boolean;  //mouseover state
    FOnMouseEnter : TNotifyEvent;
    FOnMouseLeave : TNotifyEvent;
    FOnMouseDown  : TNotifyEvent;
    FOnMouseUp    : TNotifyEvent;
    procedure CMMouseEnter(var Msg:TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Msg:TMessage); message CM_MOUSELEAVE;
    procedure WMMouseDown(var Msg:TMessage); message WM_LBUTTONDOWN;
    procedure WMMouseUp(var Msg:TMessage); message WM_LBUTTONUP;
    procedure WMEraseBkgnd(Var Msg : TMessage); message WM_ERASEBKGND;
    procedure SetpicFrom(Pic : TPicture);
    procedure SetpicTo(Pic : TPicture);
    procedure SetPicFromDown(Pic : TPicture);
    procedure SetPicToDown(Pic : TPicture);
    procedure SetGlyph(aGlyph : TPicture);
    procedure SetBRate(Val : integer);
    procedure SetProcMsg(Val : Boolean);
    procedure SetCaption(Cap : AnsiString);
    procedure SetFont(Fon : TFont);
    procedure SetActiveFont(Fon : TFont);
    procedure SetLPitch(LPitch : integer);
    procedure SetTPitch(TPitch : integer);
    procedure SetGlyphLPitch(GlyphLPitch : integer);
    procedure SetGlyphTPitch(GlyphTPitch : integer);
    procedure SetGlyphTransCl(aGlyphTransCl : TColor);
    procedure SetTransCl(aTransCl : TColor);
    procedure SetCheck(aCheck : boolean);
    procedure SetDown(aDown : boolean);
    procedure SetPlain(aPlain : boolean);
    procedure SetPitchCaption(aPitchCaption : boolean);
    procedure SetTransparent(aTransparent : boolean);
    procedure Blend;
    procedure Blendit(bFr,bTo,bLn : Pointer ; Width,Height : Integer ; Dens : LongInt);
    procedure Stretch;
    procedure Timer(sender : TObject);     //update button state
  protected
    procedure WMPosChg(var Msg : TMessage); message WM_WINDOWPOSCHANGED;
  public
    {Public Declarations}
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;
    procedure Complete;
  published
    {Published Declarations}
    property PicFrom : TPicture read FPicFrom write SetPicFrom;
    property PicTo : TPicture read FPicTo write SetPicTo;
    property PicFromDown : TPicture read FPicFromDown write SetPicFromDown;
    property PicToDown : TPicture read FPicToDown write SetPicToDown;
    property Glyph : TPicture read FGlyph write SetGlyph;
    property MorphRate : integer read FBRate write SetBRate default 32;
    property ProcessMsgs : Boolean read FProcMsg write SetProcMsg default TRUE;
    property Check : Boolean read FCheck write SetCheck default false;
    property Down : Boolean read FDown write SetDown default false;
    property Plain : Boolean read FPlain write SetPlain default false;
    property PitchCaption : Boolean read FPitchCaption write SetPitchCaption default true;
    property Transparent : Boolean read FTransparent write SetTransparent default false;
    property Cursor;
    property Hint;
    property Enabled;
    property OnClick;
    property OnMouseDown;
    property Font : TFont read FFont write SetFont;
    property ActiveFont : TFont read FActiveFont write SetActiveFont;
    property Caption : AnsiString read FCaption write SetCaption;
    property HPitch : integer read FLPitch write SetLPitch;
    property VPitch : integer read FTPitch write SetTPitch;
    property GlyphHPitch : integer read FGlyphLPitch write SetGlyphLPitch;
    property GlyphVPitch : integer read FGlyphTPitch write SetGlyphTPitch;
    property GlyphTransCl : TColor read FGlyphTransCl write SetGlyphTransCl;
    property TransCl : TColor read FTransCl write SetTransCl;
    property OnMouseUp;
    property OnMouseMove;
    property OnMouseEnter : TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave : TNotifyEvent read FOnMouseLeave write FOnMouseLeave;
    property OnDblClick;
    property OnConstrainedResize;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property OnResize;
    property OnCanResize;
    property Visible;
  end;

procedure Register;

implementation

Var
  EBX, ESI, EDI, ESP, EBP,
  FinA,
  Dens1, Dens2 : Longint;

constructor TWCButton.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FNumber:=Count;
  inc(Count);
  FBRate := 1000;
  FProcMsg := TRUE;
  FDelay := 1;
  FFont:=TFont.Create;
  FActiveFont:=TFont.Create;
  FFont.Color:=clWhite;
  FActiveFont.Color:=clWhite;
  FLPitch:=5;
  FTPitch:=10;
  ControlStyle:=ControlStyle+[csOpaque]+[csSetCaption]+[csFramed];
  FDrawn:=false;
  Enabled:=true;
  FPitchCaption:=true;
  tp:=FTPitch;
  lp:=FLPitch;

  FTimer:=TTimer.Create(Self);
  FTimer.OnTimer:=Timer;
  FTimer.Enabled:=true;
  FTimer.Interval:=500;

  FPicFrom := TPicture.Create;
  FPicTo := TPicture.Create;
  FPicFromDown := TPicture.Create;
  FPicToDown := TPicture.Create;
  FGlyph := TPicture.Create;
  FGlyph.Bitmap.Transparent:=true;
  FGlyph.Bitmap.TransparentColor:=clWhite;
  FGlyphTransCl:=clWhite;
  bmF := TBitmap.Create;
  bmT := TBitmap.Create;
  bmZ := TBitmap.Create;
  bmZ.PixelFormat:= pf24bit;
  bmF.Canvas.Brush.Style := bsClear;

  FTransparent:=false;
  FTransCl:=clWhite;
  bmF.TransparentColor:=clWhite;
  bmT.TransparentColor:=clWhite;
  bmZ.TransparentColor:=clWhite;

  Width := 120;
  Height := 50;
  bmF.Width := Width;
  bmF.Height := Height;

  Canvas.Brush.Style:=bsClear;
  Canvas.Draw(0,0,FPicFrom.Graphic);

end;

procedure TWCButton.WMEraseBkgnd(var Msg:TMessage);
begin
  Msg.Result := 1;
end;

procedure TWCButton.Paint;
begin
  if not FDrawn then begin
    FDrawn:=true;
    FGlyph.Bitmap.Transparent:=true;
    Stretch;
  end;
  if not (FGlyph.Graphic=nil) then bmF.Canvas.Draw(FGlyphLPitch,FGlyphTPitch,FGlyph.Graphic);
  Canvas.Draw(0,0,bmF);
  if not FMousePressed then Canvas.Font.Assign(FFont)
  else Canvas.Font.Assign(FActiveFont);
  Canvas.TextOut(lp,tp,FCaption);
end;

procedure TWCButton.Complete;
begin
  Canvas.Draw(0,0,bmT);
  if Assigned (FOnEnd) then FOnEnd(Self);
end;

Function Pt(B : TBitmap) : Pointer;
Begin
  Pt := B.Scanline[(B.Height-1)]
End;

procedure TWCButton.Blendit(bFr,bTo,bLn : Pointer ; Width,Height : Integer ; Dens : LongInt); assembler;

ASM

  MOV &EBX, EBX
  MOV &EDI, EDI
  MOV &ESI, ESI
  MOV &ESP, ESP
  MOV &EBP, EBP

  MOV EBX, Dens
  MOV Dens1, EBX

  NEG BL
  ADD BL, $20
  MOV Dens2, EBX
  CMP Dens1, 0
  JZ  @Final
  MOV EDI, bFr
  MOV ESI, bTo
  MOV ECX, bLn

  MOV EAX, Width
  lea EAX, [EAX+EAX*2+3]
  AND EAX, $FFFFFFFC
  IMUL Height
  ADD EAX, EDI
  MOV FinA, EAX

  MOV EBP,EDI
  MOV ESP,ESI
  MOV ECX,ECX

@LOOPA:
  MOV  EAX, [EBP]
  MOV  EDI, [ESP]
  MOV  EBX, EAX
  AND  EAX, Mask1010
  AND  EBX, Mask0101 
  SHR  EAX, 5       
  IMUL EAX, Dens2
  IMUL EBX, Dens2
  MOV  ESI, EDI     
  AND  EDI, Mask1010 
  AND  ESI, Mask0101
  SHR  EDI, 5
  IMUL EDI, Dens1
  IMUL ESI, Dens1    
  ADD  EAX, EDI
  ADD  EBX, ESI
  AND  EAX, Mask1010
  SHR  EBX, 5
  AND  EBX, Mask0101
  OR   EAX, EBX
  MOV [ECX], EAX

  ADD  EBP, 4
  ADD  ESP, 4
  ADD  ECX, 4

  CMP  EBP, FinA
  JNE  @LOOPA

@FINAL:

  MOV EBX, &EBX
  MOV EDI, &EDI
  MOV ESI, &ESI
  MOV ESP, &ESP
  MOV EBP, &EBP

End;

procedure TWCButton.Blend;
var
  r : integer;
begin
  if (not Enabled) then Exit;
  if FBRate < 1 then raise EWCButton.Create('BlendRate must be between 0 and 1000');
  if Assigned (FOnBegin) then FOnBegin(Self);
  bmZ.Canvas.Draw(0, 0, bmF);
  if not FMousePressed then bmF.Canvas.Font.Assign(FFont)
  else bmF.Canvas.Font.Assign(FActiveFont);
  FFinish:=false;
  if FPlain then begin
    bmF.Canvas.Draw(0,0,bmT);
    bmF.Canvas.Brush.Style:=bsClear;
    bmF.Canvas.TextOut(lp,tp,FCaption);
    RePaint;
    IsStopMorph:=false;
    FFinish:=true;
    Exit;
  end;
  for r := 0 to FBRate do begin
    if FProcMsg then Application.ProcessMessages;
    if IsStopMorph and (FNumber <> ActiveNumber) then begin
      IsStopMorph:=false;
      Complete;
      Exit;
    end;
    if FProcMsg then Application.ProcessMessages;
    Blendit(Pt(bmZ),Pt(bmT),Pt(bmF),bmF.Width,bmF.Height,(r*$20 Div FBRate));
    if FProcMsg then Application.ProcessMessages;
    if not (FGlyph.Graphic=nil) then bmF.Canvas.Draw(FGlyphLPitch,FGlyphTPitch,FGlyph.Graphic);
    bmF.Canvas.TextOut(lp,tp,FCaption);
    RePaint;
  end;
  FFinish:=true;
  if Assigned (FOnEnd) then FOnEnd(Self);
end;

procedure TWCButton.WMPosChg(var Msg : TMessage);
begin
  Stretch;
  Invalidate;
  inherited;
end;

procedure TWCButton.CMMouseEnter(var Msg:TMessage);
var
  tmp:integer;
begin
  inherited;
  if Assigned (FOnMouseEnter) then FOnMouseEnter(Self);

  FMouseOver:=true;
  IsStopMorph:=true;
  ActiveNumber:=FNumber;

  if (not FDown) or (not Check) then
    if not FMousePressed then bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicTo.Graphic)
    else bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicToDown.Graphic)
  else bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicToDown.Graphic);

  tmp:=FBRate;
  if FMousePressed then FBRate:=FBRate div 2;
  Blend;
  if FMousePressed then FBRate:=tmp;

end;

procedure TWCButton.CMMouseLeave(var Msg:TMessage);
var  tmp:integer;
begin
  inherited;
  if Assigned (FonMouseLeave) then FOnMouseLeave(Self);

  FMouseOver:=false;
  IsStopMorph:=true;
  ActiveNumber:=FNumber;

  if (not FDown) or (not Check) then
    if not FMousePressed then bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicFrom.Graphic)
    else bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicFromDown.Graphic)
  else bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicFromDown.Graphic);

  tmp:=FBRate;
  FBRate:=FBRate div 2;
  Blend;
  FBRate:=tmp;

end;

procedure TWCButton.WMMouseDown(var Msg:TMessage);
var
  tmp:integer;
begin
  inherited;
  if Assigned (FonMouseDown) then FOnMouseDown(Self);
  bmF.Canvas.Font.Assign(FActiveFont);
  Canvas.Font.Assign(FActiveFont);
  FMousePressed:=true;
  ActiveNumber:=FNumber;
  IsStopMorph:=true;

  if FPitchCaption then begin
    if Check and FDown then lp:=FLPitch+1;
    if Check and (not FDown) then begin
      lp:=FLPitch+1;
      tp:=FTPitch+1;
    end;
    if not FCheck then begin
      lp:=FLPitch+1;
      tp:=FTPitch+1;
    end;
  end;

  bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicToDown.Graphic);
  tmp:=FBRate;
  FBRate:=FBRate div 2;
  Blend;
  FBRate:=tmp;
end;

procedure TWCButton.WMMouseUp(var Msg:TMessage);
var
  tmp:integer;
begin
  inherited;
  if Assigned (FonMouseUp) then FOnMouseUp(Self);

  Canvas.Font.Assign(FFont);
  bmF.Canvas.Font.Assign(FFont);
  FMousePressed:=false;

  if FPitchCaption then begin
    if Check and FDown then begin
      lp:=FLPitch;
      tp:=FTPitch;
    end;
    if Check and (not FDown) then lp:=FLPitch;
    if not FCheck then begin
      lp:=FLPitch;
      tp:=FTPitch;
    end;
  end;

  if Check then FDown:=not FDown;
  ActiveNumber:=FNumber;

  if (not FDown) or (not Check) then
    if not FMouseOver then bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicFrom.Graphic)
    else bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicTo.Graphic);

  IsStopMorph:=true;
  tmp:=FBrate;
  FBRate:=FBRate div 2;
  if FFinish then Blend;
  FBRate:=tmp;
end;

procedure TWCButton.SetPicFrom(Pic : TPicture);
begin
  bmF.Canvas.StretchDraw(RECT(0,0,Width,Height),Pic.Graphic);
  Canvas.StretchDraw(RECT(0,0,Width,Height),Pic.Graphic);
  repaint;
  FPicFrom.Assign(Pic);
  Stretch;
end;

procedure TWCButton.SetPicTo(Pic : TPicture);
begin
  bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),Pic.Graphic);
  FPicTo.Assign(Pic);
  Stretch;
end;

procedure TWCButton.SetPicFromDown(Pic : TPicture);
begin
  FPicFromDown.Assign(Pic);
  Stretch;
end;

procedure TWCButton.SetPicToDown(Pic : TPicture);
begin
  FPicToDown.Assign(Pic);
  Stretch;
end;

procedure TWCButton.SetGlyph(aGlyph : TPicture);
begin
  FGlyph.Assign(aGlyph);
  FGlyph.Bitmap.Transparent:=true;
  FGlyph.Bitmap.TransparentColor:=clWhite;
end;

procedure TWCButton.SetBRate(Val : integer);
begin
  if FBRate <> Val then
    FBRate := Val;
  if FBRate < 1 then
    FBRate := 1;
  if FBRate > 3000 then
    FBRate := 3000;
end;

procedure TWCButton.Stretch;
begin
  bmF.PixelFormat := pf24bit;
  bmT.PixelFormat := pf24bit;
  bmZ.PixelFormat := pf24bit;

  bmF.Width := Width;
  bmF.Height := Height;
  bmT.Width := Width;
  bmT.Height := Height;

  if not FDown then begin
    if FPicFrom.Graphic=nil then bmF.Canvas.FillRect(RECT(0,0,Width,Height))
    else  bmF.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicFrom.Graphic);
    if FPicTo.Graphic=nil then bmT.Canvas.FillRect(RECT(0,0,Width,Height))
    else bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicTo.Graphic);
  end
  else begin
    if FPicFrom.Graphic=nil then bmF.Canvas.FillRect(RECT(0,0,Width,Height))
    else  bmF.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicFromDown.Graphic);
    if FPicTo.Graphic=nil then bmT.Canvas.FillRect(RECT(0,0,Width,Height))
    else bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicToDown.Graphic);
  end;
  bmZ.Width := Width;
  bmZ.Height := Height;

  Invalidate;

end;

procedure TWCButton.SetCaption(Cap : AnsiString);
begin
  FCaption:=Cap;
  Invalidate;
end;

procedure TWCButton.SetFont(Fon : TFont);
begin
  FFont.Assign(Fon);
  Invalidate;
end;

procedure TWCButton.SetActiveFont(Fon : TFont);
begin
  FFont.Assign(Fon);
  Invalidate;
end;

procedure TWCButton.SetLPitch(LPitch : integer);
begin
  FLPitch:=LPitch;
  Invalidate;
end;

procedure TWCButton.SetTPitch(TPitch : integer);
begin
  FTPitch:=TPitch;
  Invalidate;
end;

procedure TWCButton.SetGlyphLPitch(GlyphLPitch : integer);
begin
  FGlyphLPitch:=GlyphLPitch;
  Invalidate;
end;

procedure TWCButton.SetGlyphTPitch(GlyphTPitch : integer);
begin
  FGlyphTPitch:=GlyphTPitch;
  Invalidate;
end;

procedure TWCButton.SetGlyphTransCl(aGlyphTransCl : TColor);
begin
  FGlyphTransCl:=aGlyphTransCl;
  FGlyph.Bitmap.TransparentColor:=aGlyphTransCl;
  Invalidate;
end;

procedure TWCButton.SetTransCl(aTransCl : TColor);
begin
  FTransCl:=aTransCl;
  bmF.TransparentColor:=aTransCl;
  bmT.TransparentColor:=aTransCl;
  bmZ.TransparentColor:=aTransCl;
  Invalidate;
end;

procedure TWCButton.SetProcMsg(Val : Boolean);
begin
  if FProcMsg <> Val then
    FProcMsg := Val;
end;

procedure TWCButton.SetCheck(aCheck : Boolean);
begin
    FCheck := aCheck;
end;

procedure TWCButton.SetDown(aDown : Boolean);
begin
    FDown := aDown;
    Invalidate;
    Repaint;
end;

procedure TWCButton.Timer(sender : TObject);
var
  point : TPoint;
  tmp: integer;
begin
  point:=ScreenToClient(Mouse.CursorPos);
  if not (FMouseOver and ((point.x>Width) or (point.y>Height))) then Exit;
  FMouseOver:=false;
  IsStopMorph:=true;

  if not FMousePressed then bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicFrom.Graphic)
  else bmT.Canvas.StretchDraw(RECT(0,0,Width,Height),FPicFromDown.Graphic);

  tmp:=FBRate;
  FBRate:=FBRate div 2;
  Blend;
  FBRate:=tmp;
end;

procedure TWCButton.SetPlain(aPlain : boolean);
begin
  FPlain:=aPlain;
end;

procedure TWCButton.SetPitchCaption(aPitchCaption : boolean);
begin
  FPitchCaption:=aPitchCaption;
end;

procedure TWCButton.SetTransparent(aTransparent : boolean);
begin
  FTransparent:=aTransparent;
  bmF.Transparent:=aTransparent;
  bmT.Transparent:=aTransparent;
  bmZ.Transparent:=aTransparent;
  Invalidate;
  paint;
end;

destructor TWCButton.Destroy;
begin
  FPicFrom.Free;
  FPicTo.Free;
  FPicFromDown.Free;
  FPicToDown.Free;
  FGlyph.Free;
  bmF.Free;
  bmT.Free;
  bmZ.Free;
  inherited Destroy;
end;

procedure Register;
begin
  RegisterComponents('Standard', [TWCButton]);
end;

end.
